/*******************************************
* ZeusCMD - OpenGL Tutorial 5 : Primitives *
* By Grant James (ZEUS)                    *
* http://www.zeuscmd.com                   *
*******************************************/
#include <windows.h>
#include "glutil.h"

OpenGL *opengl;

bool init()
{
	glClearColor(0.93f, 0.93f, 0.93f, 0.0f);
	glColor3f(0.0f, 0.0f, 0.0f);

	return true;
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT);

	glBegin(GL_POINTS);
		glVertex3f( 0.7f, -0.5f, 0.0f);
		glVertex3f( 0.6f, -0.7f, 0.0f);
		glVertex3f( 0.6f, -0.8f, 0.0f);
	glEnd();

	glBegin(GL_LINE_STRIP);
		glVertex3f(-1.0f,  1.0f, 0.0f);
		glVertex3f(-0.5f,  0.5f, 0.0f);
		glVertex3f(-0.7f,  0.5f, 0.0f);
	glEnd();

	glBegin(GL_TRIANGLES);
		glVertex3f(-0.5f, -0.5f, 0.0f);
		glVertex3f( 0.5f, -0.5f, 0.0f);
		glVertex3f( 0.0f,  0.5f, 0.0f);
	glEnd();

	glBegin(GL_QUADS);
		glVertex3f(-1.0f, -1.0f, 0.0f);
		glVertex3f(-0.5f, -1.0f, 0.0f);
		glVertex3f(-0.5f, -0.5f, 0.0f);
		glVertex3f(-1.0f, -0.5f, 0.0f);
	glEnd();

	glBegin(GL_POLYGON);
		glVertex3f( 0.8f,  0.6f, 0.0f);
		glVertex3f( 0.9f,  0.8f, 0.0f);
		glVertex3f( 0.5f,  0.9f, 0.0f);
		glVertex3f( 0.6f,  0.5f, 0.0f);
	glEnd();

	glFlush();
}

void idle()
{

}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	opengl = OpenGL::create();

	opengl->setInitFunc(init);
	opengl->setDisplayFunc(display);
	opengl->setIdleFunc(idle);

	if (!opengl->initGL("05 - Primitives", 500, 500, false, 32))
		return 1;

	opengl->runMessageLoop();

	return 0;
}
